<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
<head>
  <meta charset="utf-8" />
  <meta name="generator" content="pandoc" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=yes" />
  <title>readme (2)</title>
  <style type="text/css">
      code{white-space: pre-wrap;}
      span.smallcaps{font-variant: small-caps;}
      span.underline{text-decoration: underline;}
      div.column{display: inline-block; vertical-align: top; width: 50%;}
  </style>
  <style type="text/css">
a.sourceLine { display: inline-block; line-height: 1.25; }
a.sourceLine { pointer-events: none; color: inherit; text-decoration: inherit; }
a.sourceLine:empty { height: 1.2em; }
.sourceCode { overflow: visible; }
code.sourceCode { white-space: pre; position: relative; }
div.sourceCode { margin: 1em 0; }
pre.sourceCode { margin: 0; }
@media screen {
div.sourceCode { overflow: auto; }
}
@media print {
code.sourceCode { white-space: pre-wrap; }
a.sourceLine { text-indent: -1em; padding-left: 1em; }
}
pre.numberSource a.sourceLine
  { position: relative; left: -4em; }
pre.numberSource a.sourceLine::before
  { content: attr(title);
    position: relative; left: -1em; text-align: right; vertical-align: baseline;
    border: none; pointer-events: all; display: inline-block;
    -webkit-touch-callout: none; -webkit-user-select: none;
    -khtml-user-select: none; -moz-user-select: none;
    -ms-user-select: none; user-select: none;
    padding: 0 4px; width: 4em;
    color: #aaaaaa;
  }
pre.numberSource { margin-left: 3em; border-left: 1px solid #aaaaaa;  padding-left: 4px; }
div.sourceCode
  {  }
@media screen {
a.sourceLine::before { text-decoration: underline; }
}
code span.al { color: #ff0000; font-weight: bold; } /* Alert */
code span.an { color: #60a0b0; font-weight: bold; font-style: italic; } /* Annotation */
code span.at { color: #7d9029; } /* Attribute */
code span.bn { color: #40a070; } /* BaseN */
code span.bu { } /* BuiltIn */
code span.cf { color: #007020; font-weight: bold; } /* ControlFlow */
code span.ch { color: #4070a0; } /* Char */
code span.cn { color: #880000; } /* Constant */
code span.co { color: #60a0b0; font-style: italic; } /* Comment */
code span.cv { color: #60a0b0; font-weight: bold; font-style: italic; } /* CommentVar */
code span.do { color: #ba2121; font-style: italic; } /* Documentation */
code span.dt { color: #902000; } /* DataType */
code span.dv { color: #40a070; } /* DecVal */
code span.er { color: #ff0000; font-weight: bold; } /* Error */
code span.ex { } /* Extension */
code span.fl { color: #40a070; } /* Float */
code span.fu { color: #06287e; } /* Function */
code span.im { } /* Import */
code span.in { color: #60a0b0; font-weight: bold; font-style: italic; } /* Information */
code span.kw { color: #007020; font-weight: bold; } /* Keyword */
code span.op { color: #666666; } /* Operator */
code span.ot { color: #007020; } /* Other */
code span.pp { color: #bc7a00; } /* Preprocessor */
code span.sc { color: #4070a0; } /* SpecialChar */
code span.ss { color: #bb6688; } /* SpecialString */
code span.st { color: #4070a0; } /* String */
code span.va { color: #19177c; } /* Variable */
code span.vs { color: #4070a0; } /* VerbatimString */
code span.wa { color: #60a0b0; font-weight: bold; font-style: italic; } /* Warning */
  </style>
</head>
<body>
<h3 id="life-saving-bash-scripts-part-2">Life Saving Bash Scripts Part 2</h3>
<h4 id="i-am-not-saying-theyre-in-any-way-special-compared-with-other-bash-scripts-but-when-i-consider-that-you-can-never-recover-time-spent-the-value-of-these-commands-in-my-life-quickly-becomes-incalculable">I am not saying they’re in any way special compared with other bash scripts… but when I consider that you can never recover time spent… the value of these commands in my life quickly becomes incalculable!</h4>
<p><img src="https://cdn-images-1.medium.com/max/864/0*aWKygEnTVdHuulB4.gif" /></p>
<h3 id="sanitize-directory">1.) Sanitize Directory:</h3>
<p>```shsh sanitize() {<br />
shopt -s extglob;</p>
<p>filename=$(basename “<span class="math inline">$1")\
 directory=$</span>(dirname”$1")</p>
<p>filename_clean=<span class="math inline">$(echo "$</span>filename" | sed -e ‘s/[\/:*?"&lt;&gt;|01-1F7F]//g’ -e ‘s/^(nul|prn|con|lpt[0-9]|com[0-9]|aux)(.|<span class="math inline">$\)//i' -e 's/^\.*$</span>//’ -e ‘s/^$/NONAME/’)</p>
<p>if (test “<span class="math inline">$filename" != "$</span>filename_clean”)<br />
then<br />
mv -v “<span class="math inline">$1" "$</span>directory/$filename_clean”<br />
fi<br />
}</p>
<p>export -f sanitize</p>
<p>sanitize_dir() {<br />
find “$1” -depth -exec bash -c ‘sanitize “$0”’ {} ;<br />
}</p>
<p>sanitize_dir ‘/path/to/somewhere’ <code>sh ### 2.)Recursively Delete Node Modules:</code>sh find . -name ‘node_modules’ -type d -prune -exec rm -rf ‘{}’ +</p>
<pre><code>### 3.)Remove trailing whitespace from filenames:</code></pre>
<p>rename ’s/ *<span class="math inline">$//' * ``` ### 4.)Remove string from file name: ``` for filename in *badString*; do mv "$</span>filename" “<span class="math inline">${filename//badstring/replaceString}"; done ```sh ### 5.)Remove whitespace from filenames: ```sh for file in *; do mv "$</span>file” <code>echo $file | tr ' ' '_'</code> ; done ```</p>
<h3 id="remove-script-tags-from-html-and-the-content-in-between-them.">6.) Remove <code>&lt;script&gt;</code> tags from html and the content in-between them.</h3>
<div class="sourceCode" id="cb2"><pre class="sourceCode sh"><code class="sourceCode bash"><a class="sourceLine" id="cb2-1" title="1"><span class="fu">sed</span> -n -e <span class="st">&#39;/&lt;script&gt;/,/&lt;\/script&gt;/p&#39;</span> example.html <span class="op">&gt;</span>out.js</a></code></pre></div>
<h3 id="remove-invalid-characters-from-file">7.) Remove Invalid characters from file:</h3>
<div class="sourceCode" id="cb3"><pre class="sourceCode sh"><code class="sourceCode bash"><a class="sourceLine" id="cb3-1" title="1"><span class="kw">for</span> <span class="ex">f</span> in */<span class="kw">;</span> <span class="kw">do</span> <span class="va">nf=$(</span><span class="bu">echo</span> <span class="st">&quot;</span><span class="va">$f</span><span class="st">&quot;</span> <span class="kw">|</span><span class="fu">sed</span> -e <span class="st">&#39;s/[^A-Za-z0-9.]/./g&#39;</span> -e <span class="st">&#39;s/\.\.\././g&#39;</span> -e <span class="st">&#39;s/\.\././g&#39;</span> -e <span class="st">&#39;s/\.*$//&#39;</span><span class="va">)</span>; <span class="bu">test</span> <span class="st">&quot;</span><span class="va">$f</span><span class="st">&quot;</span> != <span class="st">&quot;</span><span class="va">$nf</span><span class="st">&quot;</span> <span class="kw">&amp;&amp;</span> <span class="fu">mv</span> <span class="st">&quot;</span><span class="va">$f</span><span class="st">&quot;</span> <span class="st">&quot;</span><span class="va">$nf</span><span class="st">&quot;</span> <span class="kw">&amp;&amp;</span> <span class="bu">echo</span> <span class="st">&quot;</span><span class="va">$nf</span><span class="st">&quot;</span><span class="kw">;</span> <span class="kw">done</span></a></code></pre></div>
<h3 id="remember-git-credentials-for-future-login">8.) Remember Git Credentials For Future Login:</h3>
<div class="sourceCode" id="cb4"><pre class="sourceCode sh"><code class="sourceCode bash"><a class="sourceLine" id="cb4-1" title="1"><span class="fu">git</span> config --global credential.helper store</a></code></pre></div>
<h3 id="recursive-npm-install">9.)Recursive npm install:</h3>
<div class="sourceCode" id="cb5"><pre class="sourceCode sh"><code class="sourceCode bash"><a class="sourceLine" id="cb5-1" title="1"><span class="ex">npm</span> i -g recursive-install</a>
<a class="sourceLine" id="cb5-2" title="2"></a>
<a class="sourceLine" id="cb5-3" title="3"><span class="ex">npm-recursive-install</span></a></code></pre></div>
<h3 id="generate-numbered-folders">10.)Generate Numbered Folders:</h3>
<div class="sourceCode" id="cb6"><pre class="sourceCode sh"><code class="sourceCode bash"><a class="sourceLine" id="cb6-1" title="1"><span class="va">n=</span>1;<span class="kw">\</span></a>
<a class="sourceLine" id="cb6-2" title="2"><span class="va">max=</span>50;<span class="kw">\</span></a>
<a class="sourceLine" id="cb6-3" title="3"><span class="kw">while</span><span class="bu"> [</span> <span class="st">&quot;</span><span class="va">$n</span><span class="st">&quot;</span> <span class="ot">-le</span> <span class="st">&quot;</span><span class="va">$max</span><span class="st">&quot;</span><span class="bu"> ]</span>; <span class="kw">do\</span></a>
<a class="sourceLine" id="cb6-4" title="4">  <span class="fu">mkdir</span> <span class="st">&quot;s</span><span class="va">$n</span><span class="st">&quot;</span>\</a>
<a class="sourceLine" id="cb6-5" title="5">  n=<span class="kw">`</span><span class="fu">expr</span> <span class="st">&quot;</span><span class="va">$n</span><span class="st">&quot;</span> + 1<span class="kw">`;\</span></a>
<a class="sourceLine" id="cb6-6" title="6"><span class="kw">done</span></a></code></pre></div>
<h3 id="traverse-directories-recursivley-and-delete-files-whos-name-match-a-specified-string">11.) Traverse Directories recursivley and delete files who’s name match a specified string:</h3>
<div class="sourceCode" id="cb7"><pre class="sourceCode sh"><code class="sourceCode bash"><a class="sourceLine" id="cb7-1" title="1"><span class="fu">find</span> . -type f -exec sed -i <span class="st">&#39;/badFolder/d&#39;</span> ./* {} <span class="dt">\;</span></a></code></pre></div>
<h3 id="recursivley-remove-empty-files">12.) recursivley remove empty files:</h3>
<div class="sourceCode" id="cb8"><pre class="sourceCode sh"><code class="sourceCode bash"><a class="sourceLine" id="cb8-1" title="1"><span class="fu">find</span> . -empty -type f -print -delete</a></code></pre></div>
<h3 id="recursively-remove-empty-folders">13.)recursively remove empty folders</h3>
<div class="sourceCode" id="cb9"><pre class="sourceCode sh"><code class="sourceCode bash"><a class="sourceLine" id="cb9-1" title="1"><span class="fu">find</span> . -empty -type d -print -delete</a></code></pre></div>
<h3 id="remove-a-string-from-files-of-a-certain-extension-or-group-of-extensions">14.) Remove a string from files of a certain extension or group of extensions:</h3>
<div class="sourceCode" id="cb10"><pre class="sourceCode sh"><code class="sourceCode bash"><a class="sourceLine" id="cb10-1" title="1"><span class="fu">find</span> . -type f -a <span class="dt">\(</span> -name <span class="st">&quot;*.html&quot;</span> -o -name <span class="st">&quot;*.js&quot;</span> -o -name <span class="st">&quot;*.css&quot;</span> -o -name <span class="st">&quot;*.md&quot;</span> <span class="dt">\)</span> -a -exec sed -i  <span class="st">&#39;/BADSTRING/d&#39;</span> <span class="st">&#39;{}&#39;</span> +</a></code></pre></div>
<h3 id="recursivley-remove-from-all-html-files-any-lines-contaning-the-string-badtext">15.) Recursivley remove from all html files any lines contaning the string “badText”</h3>
<div class="sourceCode" id="cb11"><pre class="sourceCode sh"><code class="sourceCode bash"><a class="sourceLine" id="cb11-1" title="1"><span class="fu">find</span> . -type f -exec sed -i <span class="st">&#39;/badText/d&#39;</span> ./*.html {} <span class="dt">\;</span></a></code></pre></div>
<h3 id="list-the-path-of-all-html-files-in-directory-or-any-other-file-extension">16.) List the path of all html files in directory… (or any other file extension):</h3>
<div class="sourceCode" id="cb12"><pre class="sourceCode sh"><code class="sourceCode bash"><a class="sourceLine" id="cb12-1" title="1"><span class="fu">find</span> ./ <span class="kw">|</span> <span class="fu">grep</span> -i <span class="st">&quot;\.html*$&quot;</span>ls -R <span class="st">&#39;./&#39;</span> <span class="kw">|</span> <span class="fu">awk</span> <span class="st">&#39;/:$/&amp;&amp;f{s=$0;f=0}/:$/&amp;&amp;!f{sub(/:$/,&quot;&quot;);s=$0;f=1;next}NF&amp;&amp;f{ print s&quot;/&quot;$0 }&#39;</span><span class="op">&gt;</span>listing.md</a></code></pre></div>
<h3 id="delete-files-over-75mb-to-avoid-tripping-github-lfs-rules.">17.) Delete files over 75MB (to avoid tripping github LFS rules).</h3>
<div class="sourceCode" id="cb13"><pre class="sourceCode sh"><code class="sourceCode bash"><a class="sourceLine" id="cb13-1" title="1"><span class="fu">find</span> . -size +75M -a -print -a -exec rm -f {} <span class="dt">\;</span></a></code></pre></div>
<h3 id="populate-each-folder-with-a-dummy-deleteme.txt-file-recursively">18.) Populate each folder with a dummy deleteme.txt file recursively:</h3>
<div class="sourceCode" id="cb14"><pre class="sourceCode sh"><code class="sourceCode bash"><a class="sourceLine" id="cb14-1" title="1"><span class="kw">for</span> <span class="ex">x</span> in <span class="st">&quot;./&quot;</span>/*/<span class="kw">;</span> <span class="kw">do</span>  <span class="kw">(</span><span class="bu">cd</span> <span class="st">&quot;</span><span class="va">$x</span><span class="st">&quot;</span>   files=(*<span class="kw">)</span>   <span class="bu">printf</span> <span class="st">&#39;%s\n&#39;</span> <span class="st">&quot;</span><span class="va">${files[@]}</span><span class="st">&quot;</span> <span class="op">&gt;</span> deleteme.txt  )<span class="kw">done</span></a></code></pre></div>
<h1 id="pandoc">PANDOC</h1>
<h3 id="convert-from-markdown-html">19.) Convert from Markdown==⇒ HTML</h3>
<div class="sourceCode" id="cb15"><pre class="sourceCode sh"><code class="sourceCode bash"><a class="sourceLine" id="cb15-1" title="1"><span class="fu">find</span> ./ -iname <span class="st">&quot;*.md&quot;</span> -type f -exec sh -c <span class="st">&#39;pandoc --- standalone &quot;${0}&quot; -o &quot;${0%.md}.html&quot;&#39;</span> {} <span class="dt">\;</span></a></code></pre></div>
<h3 id="convert-from-html-markdown">20.) Convert from HTML ==⇒ Markdown</h3>
<div class="sourceCode" id="cb16"><pre class="sourceCode sh"><code class="sourceCode bash"><a class="sourceLine" id="cb16-1" title="1"><span class="fu">find</span> ./ -iname <span class="st">&quot;*.html&quot;</span> -type f -exec sh -c <span class="st">&#39;pandoc --- wrap=none --- from html --- to markdown_strict &quot;${0}&quot; -o &quot;${0%.html}.md&quot;&#39;</span> {} <span class="dt">\;</span></a></code></pre></div>
</body>
</html>
